# Flash Socket Policy Server
# Created by Mark Freese - Januari 2008
# www.zappmonkey.com
# Copyright 2008
# Licensed under the MIT License
# 
# Copyright (c) 2007-2008 Mark Freese
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

set policyfile	/fsp/docs/crossdomain.xml 
set port      	843
set encoding  	iso8859-1

proc policyRequest {sock clientHost clientPort} {
	puts "client connected from $clientHost $clientPort"
  	fileevent $sock readable [list sendPolicy $sock]
  	fconfigure $sock -buffering none
}

proc sendPolicy { sock } {
	
	set name $::policyfile
	
	if {[file readable $name]} {
		set inchan [open $name]
		fconfigure $inchan -translation binary
		fconfigure $sock   -translation binary
		fcopy $inchan $sock -command [list sendPolicyDone $inchan $sock]
	} else {
		puts $sock "<ERR MSG='Policy file can not be read'/>"
		close $sock
	}
}

proc sendPolicyDone {file sock bytes {msg {}}} {
	close $file
    close $sock
}

socket -server policyRequest $port
puts "Flash Policy Server is ready...."
vwait forever
